/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
	"time"
)

// checks if the CreateOrgResponseCreatedTime type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateOrgResponseCreatedTime{}

// CreateOrgResponseCreatedTime struct for CreateOrgResponseCreatedTime
type CreateOrgResponseCreatedTime struct {
	// The time the organization was created.
	Created *time.Time `json:"created,omitempty"`
	// The last time the organization was modified.
	Modified *time.Time `json:"modified,omitempty"`
}

// NewCreateOrgResponseCreatedTime instantiates a new CreateOrgResponseCreatedTime object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateOrgResponseCreatedTime() *CreateOrgResponseCreatedTime {
	this := CreateOrgResponseCreatedTime{}
	return &this
}

// NewCreateOrgResponseCreatedTimeWithDefaults instantiates a new CreateOrgResponseCreatedTime object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateOrgResponseCreatedTimeWithDefaults() *CreateOrgResponseCreatedTime {
	this := CreateOrgResponseCreatedTime{}
	return &this
}

// GetCreated returns the Created field value if set, zero value otherwise.
func (o *CreateOrgResponseCreatedTime) GetCreated() time.Time {
	if o == nil || IsNil(o.Created) {
		var ret time.Time
		return ret
	}
	return *o.Created
}

// GetCreatedOk returns a tuple with the Created field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgResponseCreatedTime) GetCreatedOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Created) {
		return nil, false
	}
	return o.Created, true
}

// HasCreated returns a boolean if a field has been set.
func (o *CreateOrgResponseCreatedTime) HasCreated() bool {
	if o != nil && !IsNil(o.Created) {
		return true
	}

	return false
}

// SetCreated gets a reference to the given time.Time and assigns it to the Created field.
func (o *CreateOrgResponseCreatedTime) SetCreated(v time.Time) {
	o.Created = &v
}

// GetModified returns the Modified field value if set, zero value otherwise.
func (o *CreateOrgResponseCreatedTime) GetModified() time.Time {
	if o == nil || IsNil(o.Modified) {
		var ret time.Time
		return ret
	}
	return *o.Modified
}

// GetModifiedOk returns a tuple with the Modified field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateOrgResponseCreatedTime) GetModifiedOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Modified) {
		return nil, false
	}
	return o.Modified, true
}

// HasModified returns a boolean if a field has been set.
func (o *CreateOrgResponseCreatedTime) HasModified() bool {
	if o != nil && !IsNil(o.Modified) {
		return true
	}

	return false
}

// SetModified gets a reference to the given time.Time and assigns it to the Modified field.
func (o *CreateOrgResponseCreatedTime) SetModified(v time.Time) {
	o.Modified = &v
}

func (o CreateOrgResponseCreatedTime) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateOrgResponseCreatedTime) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Created) {
		toSerialize["created"] = o.Created
	}
	if !IsNil(o.Modified) {
		toSerialize["modified"] = o.Modified
	}
	return toSerialize, nil
}

type NullableCreateOrgResponseCreatedTime struct {
	value *CreateOrgResponseCreatedTime
	isSet bool
}

func (v NullableCreateOrgResponseCreatedTime) Get() *CreateOrgResponseCreatedTime {
	return v.value
}

func (v *NullableCreateOrgResponseCreatedTime) Set(val *CreateOrgResponseCreatedTime) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateOrgResponseCreatedTime) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateOrgResponseCreatedTime) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateOrgResponseCreatedTime(val *CreateOrgResponseCreatedTime) *NullableCreateOrgResponseCreatedTime {
	return &NullableCreateOrgResponseCreatedTime{value: val, isSet: true}
}

func (v NullableCreateOrgResponseCreatedTime) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateOrgResponseCreatedTime) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


